# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectIdExperimentsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'data_type': 'ParametersexperimentdataType',
        'training_type': 'ParametersexperimenttrainingType',
        'name': 'Parametersexperimentname',
        'provider': 'Parametersexperimentprovider'
    }

    attribute_map = {
        'data_type': 'data_type',
        'training_type': 'training_type',
        'name': 'name',
        'provider': 'provider'
    }

    def __init__(self, data_type=None, training_type=None, name=None, provider=None):  # noqa: E501
        """ProjectIdExperimentsBody - a model defined in Swagger"""  # noqa: E501
        self._data_type = None
        self._training_type = None
        self._name = None
        self._provider = None
        self.discriminator = None
        if data_type is not None:
            self.data_type = data_type
        if training_type is not None:
            self.training_type = training_type
        if name is not None:
            self.name = name
        if provider is not None:
            self.provider = provider

    @property
    def data_type(self):
        """Gets the data_type of this ProjectIdExperimentsBody.  # noqa: E501


        :return: The data_type of this ProjectIdExperimentsBody.  # noqa: E501
        :rtype: ParametersexperimentdataType
        """
        return self._data_type

    @data_type.setter
    def data_type(self, data_type):
        """Sets the data_type of this ProjectIdExperimentsBody.


        :param data_type: The data_type of this ProjectIdExperimentsBody.  # noqa: E501
        :type: ParametersexperimentdataType
        """

        self._data_type = data_type

    @property
    def training_type(self):
        """Gets the training_type of this ProjectIdExperimentsBody.  # noqa: E501


        :return: The training_type of this ProjectIdExperimentsBody.  # noqa: E501
        :rtype: ParametersexperimenttrainingType
        """
        return self._training_type

    @training_type.setter
    def training_type(self, training_type):
        """Sets the training_type of this ProjectIdExperimentsBody.


        :param training_type: The training_type of this ProjectIdExperimentsBody.  # noqa: E501
        :type: ParametersexperimenttrainingType
        """

        self._training_type = training_type

    @property
    def name(self):
        """Gets the name of this ProjectIdExperimentsBody.  # noqa: E501


        :return: The name of this ProjectIdExperimentsBody.  # noqa: E501
        :rtype: Parametersexperimentname
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProjectIdExperimentsBody.


        :param name: The name of this ProjectIdExperimentsBody.  # noqa: E501
        :type: Parametersexperimentname
        """

        self._name = name

    @property
    def provider(self):
        """Gets the provider of this ProjectIdExperimentsBody.  # noqa: E501


        :return: The provider of this ProjectIdExperimentsBody.  # noqa: E501
        :rtype: Parametersexperimentprovider
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """Sets the provider of this ProjectIdExperimentsBody.


        :param provider: The provider of this ProjectIdExperimentsBody.  # noqa: E501
        :type: Parametersexperimentprovider
        """

        self._provider = provider

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectIdExperimentsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectIdExperimentsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
